require("road.nut");
require("general.nut");

import("pathfinder.road", "RoadPathFinder", 4);


class SmallTownAI extends AIController {


   function Start();
}

function SmallTownAI::Start() {

   local serviced_towns = AITownList();
   serviced_towns.RemoveList(serviced_towns);

   //set the name of our ai
   if (!AICompany.SetName("The Company")) {
      if (!AICompany.SetName("The 2nd Company")) {
			if(!AICompany.SetName("The 3rd Company")) {
         local i = 4;
         local named = false;
         while(named = false); {
            if(AICompany.SetName("The " + i + "th Company")) {
					named = true;
            }
            i ++;
				}      
         }
      }
   }

   local bus = null;
   //create a list of the unserviced towns between 250 and 1500 population.
   AILog.Info("Searching for a small town...");
   local town_list = AITownList();
   town_list.RemoveList(serviced_towns);
   town_list.Valuate(AITown.GetPopulation);
   town_list.KeepAboveValue(250);
   town_list.KeepBelowValue(1250);
   AILog.Info("Number of potential towns: " + town_list.Count());
   town_list.KeepTop(1);
   AILog.Info("Town Found! Building network...");
   local town = town_list.Begin();

   //build a road network in the desired town
   local depot = create_network(town);

	//keep trying to build a new network until no error is giver
	while(depot < -10) {

		this.Sleep(100);
		
		AILog.Info("Searching for a small town...");
	   local town_list = AITownList();
   	town_list.RemoveList(serviced_towns);
   	town_list.Valuate(AITown.GetPopulation);
   	town_list.KeepAboveValue(250);
   	town_list.KeepBelowValue(1200);
   	AILog.Info("Number of potential towns: " + town_list.Count());
   	town_list.KeepTop(1);
   	AILog.Info("Town Found! Building network...");
   	local town = town_list.Begin();
		depot = create_network(town);
	}

   //add the serviced town to the serviced towns list
   serviced_towns.AddItem(town, 1);

   local first_town = 1
	
	AILog.Info("Taking initial loan");
	AICompany.SetLoanAmount(AICompany.GetLoanAmount() + 100000);

   //create a loop so that our ai doesn't end
   while (true) {

		if(AICompany.GetBankBalance(AICompany.COMPANY_SELF) > 25000 && serviced_towns.Count() < 12) {
			//find a nearby town
   		local second_town = find_nearby_town(AITown.GetLocation(serviced_towns.Begin()), serviced_towns);

   		//build a path from the current town to the next town and, if successful, build a station and order busses to go there
   		local new_station = null;
   		if(build_path(AITown.GetLocation(serviced_towns.Begin()), AITown.GetLocation(second_town))) {
				new_station = build_station(AITown.GetLocation(second_town))
				if(new_station != -10) {
	
	
		  			//build a bus
					bus = build_bus(depot);

					//order the bus to go between the most crowded station and the new station.
					local stations = AIStationList(AIStation.STATION_BUS_STOP);
					stations.Valuate(AIStation.GetCargoWaiting, AICargo.CC_PASSENGERS);
					stations.Sort(1, true);
					stations.KeepTop(1);
					AILog.Info("Ordering bus to " + AIBaseStation.GetName(stations.Begin()));
				  	AIOrder.InsertOrder(bus, 0, AIBaseStation.GetLocation(stations.Begin()), AIOrder.OF_NONE);
					stations.RemoveValue(new_station);
					AILog.Info("Ordering bus to " + AIBaseStation.GetName(new_station));
					AIOrder.InsertOrder(bus, 1, new_station, AIOrder.OF_NONE);
	
					//start the bus
					AILog.Info("New route complete, starting bus transport!");
					AIVehicle.StartStopVehicle(bus);
				}
			   serviced_towns.AddItem(second_town, -1);
			}

		   //try to repay our loan
			//AILog.Info("Trying to repay part of loan...");
		   //AICompany.SetLoanAmount(AICompany.GetLoanAmount() - 10000);

		  // this.Sleep(500);
		}
		//try to repay our loan
		AILog.Info("Trying to repay part of loan...");
	   AICompany.SetLoanAmount(AICompany.GetLoanAmount() - 10000);

		//replace old vehicles
		renew_buses(depot);

		this.Sleep(500);
	}
}




